#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n;
vector<int> gr[100005];
bool br[100005];
int st[100005];

void dfs(int vr)
{
    int brs=gr[vr].size();
    for(int i=0; i<brs; i++)
    {
        dfs(gr[vr][i]);
        st[vr]+=st[gr[vr][i]];
    }
    st[vr]++;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=0; i<n-1; i++)
    {
        int u, v;
        cin>>u>>v;
        gr[u].push_back(v);
        br[v]=1;
    }
    int rt=-1;
    for(int i=1; i<=n; i++) if(br[i]==0) rt=i;
    dfs(rt);
    int m;
    cin>>m;
    for(int j=0; j<m; j++)
    {
        int t;
        cin>>t;
        cout<<st[t]-1<<endl;
    }
    return 0;
}

